#define _AWACS_CARD_C_
/*
 * sound/awacs_card.c
 *
 * Detection routine for the AWACS sound chip.
 */

#include <linux/config.h>

#include "sound_config.h"

#if defined(CONFIG_AWACS)

#undef DEB
#define DEB(what)	/* (what) */
#undef DEB2
#define DEB2(what)	/* (what) */

static int			awacs_irq = 0;
int					*awacs_osp;

/******************* Begin of the Interrupt Handler ********************/

void
awacsintr (int irq, void *dev_id, struct pt_regs *dummy)
{
}

/******************* End of the Interrupt handler **********************/

/******************* Begin of the Initialization Code ******************/

int
config_awacs_hw (struct address_info *hw_config)
{
char		ok = 1;

DEB (printk ("config_awacs_hw: configuring awacs hardware\n"));

	awacs_irq = hw_config->irq;

#if 0
	if (awacs_irq < 0 || awacs_irq > 0xff)
	{
		printk ("AWACS: Invalid IRQ %d", awacs_irq);
		ok = 0;
	}
	else
	{
		/* do IRQ stuff here */
	}
#endif

	if (hw_config->dma >= 0)
	{
		/* allocate dma, write the dma data as necessary */
		if (sound_alloc_dma(hw_config->dma, "AWACS"))
		{
			printk("config_awacs_hw: can't alloc DMA channel");
			ok = 0;
		}
/*		else
			printk("DMA channel %d allocated for AWACS\n", hw_config->dma);
*/	}

	if (hw_config->dma2 >= 0)
	{
		/* allocate dma, write the dma data as necessary */
		if (sound_alloc_dma(hw_config->dma2, "AWACS"))
		{
			printk("config_awacs_hw: can't alloc 2nd DMA channel");
			ok = 0;
		}
/*		else
			printk("2nd DMA channel %d allocated for AWACS\n", hw_config->dma2);
*/	}

	if (!ok)
		printk ("AWACS: Driver not enabled\n");
	else
		printk ("AWACS: Driver enabled.\n");

	return ok;
}

void
attach_awacs_card (struct address_info *hw_config)
{
DEB (printk ("attach_awacs_card: attaching AWACS.\n"));

	if (config_awacs_hw(hw_config))
	{
		conf_printf ("PowerMac AWACs found", hw_config);
	
#ifdef CONFIG_AUDIO
		awacs_pcm_init (hw_config);
#endif

#ifdef CONFIG_MIDI
		awacs_midi_init ();
#endif

		awacs_init_mixer ();
	}
}

int
probe_awacs (struct address_info *hw_config)
{
DEB (printk ("probe_awacs: probing for AWACS card.\n"));

	awacs_osp = hw_config->osp;
	return 1;
}

void
unload_awacs (struct address_info *hw_config)
{
DEB (printk ("unload_awacs: unloading AWACS.\n"));

	/* free dma, as necessary */
	snd_release_irq (hw_config->irq);
}

#endif
