#ifndef __PPC_UNALIGNED_H
#define __PPC_UNALIGNED_H

/*
 * The PowerPC can do unaligned accesses itself in big endian mode. 
 * XXX Well, the 403 doesn't!
 *
 * The strange macros are there to make sure these can't
 * be misused in a way that makes them not work on other
 * architectures where unaligned accesses aren't as simple.
 */

#define get_unaligned(ptr) ({unsigned char *__pt1, *__pt2; int __i; unsigned int __v = 0; \
	__pt1 = (unsigned char *)ptr; \
	__pt2 = (unsigned char *)&__v + (sizeof(unsigned int) - sizeof(*ptr)); \
	for (__i = 0; __i < sizeof(*ptr); __i++) \
		*__pt2++ = *__pt1++; \
	__v; })


#define put_unaligned(val, ptr) \
	({unsigned char *__pt1, *__pt2; int __i; unsigned int __v; \
	  __v = (unsigned int)val; \
	  __pt1 = (unsigned char *)ptr; \
	  __pt2 = (unsigned char *)&__v + (sizeof(unsigned int) - sizeof(*ptr)); \
	  for (__i = 0; __i < sizeof(*ptr); __i++) \
	  	*__pt1++ = *__pt2++; \
	})

#endif
