#ifndef _TIVODEFS_H
#define _TIVODEFS_H

#define TIVO_BOOT_MAGIC 0x1492

struct tcdbootpage {
    short signature;
    char primaryBootPartition;
    char alternateBootPartition;
    char bootParams[128];
    char hostName[32];
    int ipAddress;
    unsigned char macAddress[6];
    unsigned char rfchan;
#define SCART_STANDBY   1
#define SCART_NOCONTROL 2
    unsigned char scartstate;
    char netBootName[128];
    char rfu_mbz [208];
};

/* make sure that the following is compliant w/ the prom code !!!!
 * prom/ppc/include/devices.h
 */
#define MAXDEVICES 6

typedef struct {
    long    nvramid[2];             /* Validity check field            */
    int     conf_size;              /* Size of this structure          */
    int     numdev;                 /* Number of entries               */
    int     nomenu;                 /* Wait for input                  */
    int     autolockdisk;           /* Exit to debugger                */
    int     numboot;                /* Number of boot devices          */
    int     numtest;                /* Number of device tests          */
    char    mac_address[6];
    char    hostname[32];
    struct {
        unsigned long src;      /* Source IP address               */
        unsigned long dst;      /* Dest. IP address                */
        char    present;        /* device present                  */
        char    noboot;         /* Don't boot from device          */
        char    bootorder;      /* boot order                      */
        char    notest;         /* Don't test device               */
        int     baud;           /* Baud rate (for s1 download only)*/
    } ipaddr[MAXDEVICES];
    char bootparam[128];
    int  memconfig;
    int  videoconfig;
    unsigned long gateway;          /* sometimes correct. */
    unsigned long tunerconfig;
    int     cpuclock;               /* cpuclock | magic value       */
    int     fastboot;               /* Skip kernel signature check */
} nvram_t;

#endif /* _TIVODEFS_H */
